using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication7
{
    class Program
    {
        static void Main(string[] args)
        {
            var ulaz = Console.ReadLine().Split();
            int N = int.Parse(ulaz[0]);
            int M = int.Parse(ulaz[1]);
            Int16 K = Int16.Parse(ulaz[2]);
            int[,] A = new int[N, M];
            for (int i = 0; i < K; i++)
            {
                var ulaz1 = Console.ReadLine().Split();
                int x = int.Parse(ulaz[0]);
                int y = int.Parse(ulaz[1]);
            }

            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < M; j++)
                {
                    if (A[i, j] != 0)
                    {
                        A[i, j] = -1;
                    }
                }
            }
            int boja = 1;
            int brojpraznih = N * M - K;
            while (brojpraznih > 0)
            {
                for (int i = 0; i < N; i++)
                {
                    for (int j = 0; j < M; j++)
                    {
                        if (A[i, j] != 0)
                        {
                            A[i, j] = -1;
                        }
                        if (A[i, j] == -1)
                        {
                            A[i, j] = boja;
                            brojpraznih--;
                            if (i > 0)
                            {
                                A[i - 1, j] = boja;
                                brojpraznih--;
                            }
                            if (i < N - 1)
                            {
                                A[i + 1, j] = boja;
                                brojpraznih--;
                            }
                            if (j < M - 1)
                            {
                                A[i, j + 1] = boja;
                                brojpraznih--;
                            }
                            if (j > 0)
                            {
                                A[i, j - 1] = boja;
                                brojpraznih--;
                            }
                        }
                        if (i > 0)
                        {
                            if (A[i - 1, j] == boja)
                            {
                                A[i, j] = boja;
                                brojpraznih--;
                            }
                        }
                        if (i < N - 1)
                        {
                            if (A[i + 1, j] == boja)
                            {
                                A[i, j] = boja;
                                brojpraznih--;
                            }
                        }
                        if (j < M - 1)
                        {
                            if (A[i, j + 1] == boja)
                            {
                                A[i, j] = boja;
                                brojpraznih--;
                            }
                        }
                        if (j > 0)
                        {
                            if (A[i, j - 1] == boja)
                            {
                                A[i, j] = boja;
                                brojpraznih--;
                            }
                        }
                    }
                }
                boja++;
            }
            Console.WriteLine(boja--);
        }
    }
}